from pydantic import UUID4, PositiveInt, NegativeInt

from src.schemas import MessageFromChatSchema, BaseModelWithSerializeDatetime


class ChatMessageSchema(BaseModelWithSerializeDatetime):
    slice_id: UUID4
    messages: list[MessageFromChatSchema]


class FullRequestForGeminiSchema(BaseModelWithSerializeDatetime):
    chats: list[ChatMessageSchema]


class SuccessChatFromAiSchema(BaseModelWithSerializeDatetime):
    user_id: PositiveInt | None
    slice_id: UUID4 | None
    reason: str | None


class ResponseFromGeminiSchema(BaseModelWithSerializeDatetime):
    success: list[SuccessChatFromAiSchema] | None

