
from faststream.rabbit import RabbitBroker, RabbitExchange, ExchangeType, RabbitQueue

from src.gemini_sdk.schemas import ResponseFromGeminiSchema
from src.settings.base import settings




broker = RabbitBroker(
    url=settings.RABBIT.URL,
)


base_exchange = RabbitExchange(
    name="base_exchange",
    type=ExchangeType.DIRECT,
)

base_queue = RabbitQueue(
    name="base_queue",
)
success_queue = RabbitQueue(
    name="success_queue",
)


message_subscriber = broker.subscriber(
    queue=base_queue,
    exchange=base_exchange,
)

success_publisher = broker.publisher(
    queue=success_queue,
    exchange=base_exchange,
    schema=ResponseFromGeminiSchema,
)


async def init_queue_and_publisher():
    await broker.declare_exchange(base_exchange)
    await broker.declare_queue(base_queue)
    await broker.declare_queue(success_queue)

