import json

from google.generativeai import GenerativeModel

from src.service.storage import MESSAGES_STORAGE_SCHEMA
from src.settings.base import settings


def check_current_token_limit(
        model: GenerativeModel
) -> bool:
    raw_response = json.dumps(MESSAGES_STORAGE_SCHEMA.model_dump_json())

    tokens_response_count = model.count_tokens(raw_response).total_tokens
    print("tokens", model.count_tokens(raw_response).total_tokens)
    if tokens_response_count >= settings.GEMINI.TOKENS_LIMIT:
        return False

    return True
